#include "cam.hpp"

////////////////////////////////////////////////     
////////////////////////////////////////////////     
////////////////////////////////////////////////     
////////////////////////////////////////////////     

//THIS IS BASE 0, FIX IT FIX IT


     void Cam::loadFrustum(Matrix4x4 proj)     
     {
       //left
       plane[0][0] = proj[3][0] + proj[0][0];
       plane[0][1] = proj[3][1] + proj[0][1];
       plane[0][2] = proj[3][2] + proj[0][2];
       planedist[0] = proj[3][3] + proj[0][3];
     
       //right
       plane[1][0] = proj[3][0] - proj[0][0];
       plane[1][1] = proj[3][1] - proj[0][1];
       plane[1][2] = proj[3][2] - proj[0][2];
       planedist[1] = proj[3][3] - proj[0][3];
     
       //top
       plane[2][0] = proj[3][0] - proj[1][0];
       plane[2][1] = proj[3][1] - proj[1][1];
       plane[2][2] = proj[3][2] - proj[1][2];
       planedist[2]= proj[3][3] - proj[1][3];
     
       //bottom
       plane[3][0] = proj[3][0] + proj[1][0];
       plane[3][1] = proj[3][1] + proj[1][1];
       plane[3][2] = proj[3][2] + proj[1][2];
       planedist[3] = proj[3][3] + proj[1][3];
     
       //near
       plane[4][0] = proj[3][0] + proj[2][0];
       plane[4][1] = proj[3][1] + proj[2][1];
       plane[4][2] = proj[3][2] + proj[2][2];
       planedist[4] = proj[3][3] + proj[2][3];
     
       //far
       plane[5][0] = proj[3][0] - proj[2][0];
       plane[5][1] = proj[3][1] - proj[2][1];
       plane[5][2] = proj[3][2] - proj[2][2];
       planedist[5] = proj[3][3] - proj[2][3];
     
       
       
       for (int i = 0; i < 6; i++)
       {
         double factor = plane[i].normalize();
	 planedist[i] = planedist[i] / factor;
       } 
       
   
       
     }
     
     int Cam::containsSphere(Point3D pos, double radius)     
     {
        // various distances
       double distance;

        // calculate our distances to each of the planes
       for(int i = 0; i < 6; i++) 
       {

         // find the distance to this plane
         distance = plane[i][0] * pos[0] + plane[i][1] * pos[1] + plane[i][2] * pos[2] + planedist[i];
         // if this distance is < -sphere.radius, we are outside
         if(distance < -radius)
            return(0);

         // else if the distance is between +- radius, then we intersect
         if(fabs(distance) < radius)
           return(1);
       }

       // otherwise we are fully in view
       return(2);
     }
