#include "material.hpp"

Material::~Material()
{
}

PhongMaterial::PhongMaterial(const Colour& kd, const Colour& ks, double shininess)
  : m_kd(kd), m_ks(ks), m_shininess(shininess)
{

}



PhongMaterial::PhongMaterial()
  : m_kd(0), m_ks(0), m_shininess(1)
{

}


PhongMaterial::~PhongMaterial()
{
}

void PhongMaterial::apply_gl(double alpha) const
{
    glColor4d(m_kd.R(), m_kd.G(), m_kd.B(), alpha);
    GLfloat specular [] = { m_ks.R(), m_ks.G(), m_ks.B(), alpha };
    GLfloat shininess [] = { m_shininess };
    GLfloat diffuse[] = {m_kd.R(), m_kd.G(), m_kd.B(), alpha}; 
    glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, specular);
    glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, shininess);
    glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, diffuse);
  
  // Perform OpenGL calls necessary to set up this material.
}
