#ifndef CS488_MATERIAL_HPP
#define CS488_MATERIAL_HPP

#include "algebra.hpp"
#include <GL/gl.h>
#include <GL/glu.h>
class Material {
public:
  virtual ~Material();
  virtual void apply_gl(double alpha) const = 0;

protected:
  Material()
  {
  }
};

class PhongMaterial : public Material {
public:
  PhongMaterial(const Colour& kd, const Colour& ks, double shininess);
  virtual void apply_gl(double alpha) const;

  PhongMaterial();
  virtual ~PhongMaterial();

  virtual const Colour get_diffuse() const { return m_kd; }
  virtual const Colour get_specular() const { return m_ks; }
  virtual const double get_shininess() const { return m_shininess; }

private:
  Colour m_kd;
  Colour m_ks;

  double m_shininess;
};


#endif
