#include "world.hpp"
#include <limits>

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Add a pointer to a texture, and the number of consequtive textures to pick from, as a possibility for
// multiple textures
//


#define EPSILON 0.000001

bool World::showNormal = false;
bool World::animateNormal = true;
bool World::showBound = false;
bool World::showFaceNormal = false;


#define NUMINC 40

//#define SPLITX 16
//#define SPLITY 16

#define SPLITX 32
#define SPLITY 32

//have to split the planes up, damn it

 //http://www.gamespp.com/algorithms/collisionDetectionTutorial01.html
 //http://www.gamespp.com/algorithms/collisionDetectionTutorial02.html


//http://www.gamedev.net/reference/list.asp?categoryid=45#99

World::World(std::string dispname, double scale, Matrix4x4 trans)
{


    
    m_scale = scale;
    m_trans = trans;
    
    doHeartBeat = true;
    
    textureoffsetx = 300.0 * (double)rand() / (RAND_MAX+1);
    textureoffsety = 300.0 * (double)rand() / (RAND_MAX+1);
    
    inc = 0;
    
    if (!displace.loadPng(dispname))
      std::cerr << "Png failed to load" << std::endl;
    
    envStartX = 0;
    envStartY = 0;
    envWidth = displace.width();
    envHeight = displace.height();

    
    
    grid = new Point3D*[envWidth];
    for (int i = 0; i < envWidth; i++)
      grid[i] = new Point3D[envHeight];

    normal = new Vector3D*[envWidth];
    for (int i = 0; i < envWidth; i++)
      normal[i] = new Vector3D[envHeight];
    
    planeNormal = new Vector3D*[envWidth];
    for (int i = 0; i < envWidth; i++)
      planeNormal[i] = new Vector3D[envHeight];

    
    textureCoord = new Point2D*[envWidth];
    for (int i = 0; i < envWidth; i++)
      textureCoord[i] = new Point2D[envHeight];
    


      
            
      
          
    for (int i = 0; i < envWidth; i++)
      for (int j = 0; j < envHeight; j++)
        {
	   grid[i][j] = m_trans * translation(Vector3D(-(double)envWidth/2, -(double)envHeight/2+0.5, 0)) * Point3D(i, envHeight-j-1, (-(double)displace(i,j,0))*scale);
	      
	}
	
    for (int i = 0; i < envWidth; i++)
      for (int j = 0; j < envHeight; j++)
      {
          Vector3D n = getNormal(grid, i, j, envWidth, envHeight);
          normal[i][j] = n;
          if (m_scale < 0) { n = -1 * n; }
          //normal[i][j] = m_trans * n;
          normal[i][j].normalize();
      }

      
      
    //double textscalex = 0.1;
    //double textscaley = 0.1;
    double textscalex = 1;
    double textscaley = 1;
    
    for (int j = 0; j < envHeight-1; j++)
    {
      textureCoord[envWidth-1][j+1] = Point2D(grid[envWidth-1][j+1][0]/envWidth/textscalex, 1-grid[envWidth-1][j+1][1]/envHeight/textscaley);
      textureCoord[envWidth-1][j] = Point2D(grid[envWidth-1][j][0]/envWidth/textscalex, 1-grid[envWidth-1][j][1]/envHeight/textscaley);
      for (int i = envWidth-1; i > 0 ; i--)
      {
       textureCoord[i-1][j+1] = Point2D(grid[i-1][j+1][0]/envWidth/textscalex, 1-grid[i-1][j+1][1]/envHeight/textscaley);
       textureCoord[i-1][j] = Point2D(grid[i-1][j][0]/envWidth/textscalex, 1-grid[i-1][j][1]/envHeight/textscaley);
      }
    }
      
      
      
      
    
      
      
      
      
      
/*      
    glNewList(PLANE, GL_COMPILE);
    
   
    glPushMatrix();
    
    glColor3d(1, 1, 1);

    glScaled(10,10,10);
    glTranslated(-displace.width()/2, -displace.height()/2, 0);


    //glRotated(180, 1, 0, 0);
    double textscalex = 0.1;
    double textscaley = 0.1;
    for (int j = 0; j < displace.height()-1; j++)
    {
      //beginning a new strip  
      glBegin(GL_TRIANGLE_STRIP);
      glNormal3dv(normal[displace.width()-1][j+1].begin());
      glTexCoord2d(grid[displace.width()-1][j+1][0]/displace.width()/textscalex, 1-grid[displace.width()-1][j+1][1]/displace.height()/textscaley);
      glVertex3dv(grid[displace.width()-1][j+1].begin());
      glTexCoord2d(grid[displace.width()-1][j][0]/displace.width()/textscalex, 1-grid[displace.width()-1][j][1]/displace.height()/textscaley);
      glNormal3dv(normal[displace.width()-1][j].begin());
      glVertex3dv(grid[displace.width()-1][j].begin());
      for (int i = displace.width()-1; i > 0 ; i--)
      {
       glTexCoord2d(grid[i-1][j+1][0]/displace.width()/textscalex, 1-grid[i-1][j+1][1]/displace.height()/textscaley);
       glNormal3dv(normal[i-1][j+1].begin());
       glVertex3dv(grid[i-1][j+1].begin());
       glTexCoord2d(grid[i-1][j][0]/displace.width()/textscalex, 1-grid[i-1][j][1]/displace.height()/textscaley);
       glNormal3dv(normal[i-1][j].begin());
       glVertex3dv(grid[i-1][j].begin());
      }
      glEnd();
    }
      
  

      
    
    glPopMatrix();
    glEndList();
      
  */    


    incAngle = new double[NUMINC];
    animatedNormals = new Vector3D**[NUMINC];

    
   
    
    for (int i = 0; i < NUMINC; i++)
    {
       if (m_scale < 0)
         incAngle[NUMINC-1-i] = i*((M_PI*(double)2)/(double)NUMINC);
       else
         incAngle[i] = i*((M_PI*(double)2)/(double)NUMINC);
    }      
    
    
    double *incAngle2 = new double[NUMINC];
    for (int i = 0; i < NUMINC/2+1; i++)
    {
         incAngle2[i] = i*((M_PI*(double)2)/(double)NUMINC) / 5;
    }      
    for (int i = NUMINC-1; i >= NUMINC/2-1; i--)
    {
         incAngle2[i] = incAngle2[NUMINC-i+1];
    }      
    
    if (m_scale < 0)
    {
     for (int i = 0; i < NUMINC; i++)
       incAngle2[i] = -incAngle2[i];
    }      
    
    
    for (int i = 0; i < NUMINC; i++)
    {
      double cosinc = cos(incAngle[i]);
      double sininc = sin(incAngle[i]);
 
      if (m_scale < 0)
      {
       sininc = -sininc;
      // cosinc = cosinc;
      }
      animatedNormals[i] = new Vector3D*[envWidth];
      for (int j = 0; j < envWidth; j++)
        animatedNormals[i][j] = new Vector3D[envHeight];

      for (int j = 0; j < envWidth; j++)
        for (int k = 0; k < envHeight; k++)
        {
          Vector3D n = normal[j][k];
          //animatedNormals[i][j][k] = 0.5 * n + 0.5 * Vector3D(n[0] * cosinc - n[1] * sininc, n[0] * sininc + n[1] * cosinc, n[2]);
          animatedNormals[i][j][k] = rotation(incAngle2[i], 'y') * n;
	}


    }

    

    ep = new WorldPortion*[SPLITX*SPLITY];
    
    int divx = envWidth / SPLITX;
    int divy = envHeight / SPLITY;
    for (int i = 0; i < SPLITX; i++)
     for (int j = 0; j < SPLITY; j++)
       {
         int startx = i * divx;
	 int starty = j * divy;
	 if (startx != 0) startx = startx - 1;  //adjust to reuse verts to avoid little bars
	 if (starty != 0) starty = starty - 1;
	 ep[j*SPLITX+i] = new WorldPortion(startx, starty, (i+1)*divx, (j+1)*divy, m_scale, grid, normal, planeNormal, textureCoord, incAngle, animatedNormals);
       }


    
}

World::~World()
{
    for (int i = 0; i < envWidth; i++)
      delete [] grid[i];
    delete [] grid;  

    for (int i = 0; i < envWidth; i++)
      delete [] normal[i];
    delete [] normal;  

    for (int i = 0; i < envWidth; i++)
      delete [] textureCoord[i];
    delete [] textureCoord;  

}

void World::render(Cam *c, Uint32 outerTicks)
{

    if (!doHeartBeat)
    {
      if (outerTicks > heartBeatTimer)
      {
        
        doHeartBeat = true;
      }
      inc = 0;
    }
    
    if (doHeartBeat)
    {
      
      inc = inc + 1; 
      if (inc >= NUMINC) 
      { 
        inc = 0;
        doHeartBeat = false;
        heartBeatTimer = outerTicks + 300;
      }
      
    }  


    for (int i = 0; i < SPLITX*SPLITY; i++)
	ep[i]->render(c, inc);
     



  
}



Vector3D World::getNormal(Point3D **grid, int i, int j, int width, int height)
//work out the averaged normal for point i,j in the grid (of size width, height)
// where every point is part of 6 triangles (except for outer cases
// Other triangles consist of points
// Up, Left
// Up, and Up-right
// Up-right and Right
// Left and Down-left
// DownLeft and Down
// Right and Down
{
   Vector3D norm;
   norm = Vector3D(0,0,0);
   int contrib = 0;
   
   //Up, Left
   if (j != 0 && i != 0)
   {
     Point3D up = grid[i][j-1];
     Point3D left = grid[i-1][j];
     Point3D cur = grid[i][j];
     Vector3D newnorm = (up - cur).cross(left - cur);
     //if (newnorm[2] < 0) newnorm = -1 * newnorm;
     norm = norm + newnorm;
     contrib++;
   }   
   
   //Up, UpRight
   if (j != 0 && i != width-1)
   {
     Point3D up = grid[i][j-1];
     Point3D upright = grid[i+1][j-1];
     Point3D cur = grid[i][j];
     Vector3D newnorm = (cur - up).cross(upright - cur);
     //if (newnorm[2] < 0) newnorm = -1 * newnorm;
     
     norm = norm + newnorm;

     contrib++;
   }   
   //UpRight, Right
   if (j != 0 && i != width-1)
   {
     Point3D upright = grid[i+1][j-1];
     Point3D right = grid[i+1][j];
     Point3D cur = grid[i][j];
     Vector3D newnorm = (cur - upright).cross(right - cur);
     //if (newnorm[2] < 0) newnorm = -1 * newnorm;

     norm = norm + newnorm;

     contrib++;
   }   

   //Left, DownLeft
   if (j != height-1 && i != 0)
   {
     Point3D left = grid[i-1][j];
     Point3D downleft = grid[i-1][j+1];
     Point3D cur = grid[i][j];
     Vector3D newnorm = (left - cur).cross(downleft - cur);
     //if (newnorm[2] < 0) newnorm = -1 * newnorm;
     norm = norm + newnorm;
     
     contrib++;
   }   
   
   //DownLeft, Down
   if (j != height-1 && i != 0)
   {
     Point3D down = grid[i][j+1];
     Point3D downleft = grid[i-1][j+1];
     Point3D cur = grid[i][j];
     Vector3D newnorm = (cur - down).cross(downleft - cur);
     //if (newnorm[2] < 0) newnorm = -1 * newnorm;
     norm = norm + newnorm;

     contrib++;
   }   
   //Right, Down
   if (j != height-1 && i != width-1)
   {
     Point3D right = grid[i+1][j];
     Point3D down = grid[i][j+1];
     Point3D cur = grid[i][j];
     Vector3D newnorm = (cur - right).cross(down - cur);
     //if (newnorm[2] < 0) newnorm = -1 * newnorm;
     norm = norm + newnorm;

     contrib++;
   }   

   norm = ((double)1 / (double)contrib) * norm;
   norm.normalize();
   return norm;
}















bool World::intersect(Point3D pos, Vector3D dir, double rad, bool reverse, Vector3D &norm, double &dist)
{  
  dir.normalize(); 
  for (int i = 0; i < SPLITX*SPLITY; i++)
   {
     if (ep[i]->intersect(pos, dir, rad, reverse, norm, dist) == true) { return true; }
   }
  return false;
}


































WorldPortion::WorldPortion(int startX, int startY, int width, int height, double scale, Point3D **grid, Vector3D **normal, Vector3D **planeNormal, Point2D **textureCoord, double *incAngle, Vector3D ***animatedNormals)
{


    
    m_display = true;
    
    m_scale = scale;
    doHeartBeat = true;
    
    textureoffsetx = 1; //300.0 * (double)rand() / (RAND_MAX+1);
    textureoffsety = 1; //300.0 * (double)rand() / (RAND_MAX+1);
    
    inc = 0;
    
    
    envStartX = startX;
    envStartY = startY;
    envWidth = width;
    envHeight = height;

    
    
    this->grid = grid;
    this->normal = normal;
    this->planeNormal = planeNormal;
    this->textureCoord = textureCoord;
    this->incAngle = incAngle;
    this->animatedNormals = animatedNormals;
    
    
  BBp1 = Point3D(std::numeric_limits<double>::max(),std::numeric_limits<double>::max(),std::numeric_limits<double>::max());
  BBp2 = Point3D(-std::numeric_limits<double>::max(),-std::numeric_limits<double>::max(),-std::numeric_limits<double>::max());
  for (size_t i = envStartX; i < envWidth; i++)
    for (size_t j = envStartY; j < envHeight; j++)
    {
      Point3D p = grid[i][j];
      for (size_t k = 0; k < 3; k++)
      {
        if (p[k] < BBp1[k]) BBp1[k] = p[k];
        if (p[k] > BBp2[k]) BBp2[k] = p[k];
      }
    }
    
    
   sphereCenter = Point3D((BBp1[0] + BBp2[0]) / 2,(BBp1[1] + BBp2[1]) / 2,(BBp1[2] + BBp2[2]) / 2);
   sphereRadius = (BBp2 - sphereCenter).length();

    
    
    //std::cerr << envHeight << "  " << envStartY << "  "  << envWidth << "  " << envStartX << std::endl;
    //std::cerr << (envHeight-envStartY)*(envWidth-envStartX) << std::endl;
    
    
    faceList = new Point3D*[(envHeight-envStartY)*(envWidth-envStartX) * 2];
    for (int i = 0; i < (envHeight-envStartY)*(envWidth-envStartX) * 2; i++)
      faceList[i] = new Point3D[3];
    
    normalList = new Vector3D[(envHeight-envStartY)*(envWidth-envStartX) * 2];
    
    int dex = 0;  
    for (int j = envStartY; j < envHeight-1; j++)
    {
      //beginning a new strip  
        for (int i = envWidth-1; i > envStartX ; i--)
        {
           Point3D downleft = grid[i-1][j+1];
           Point3D upleft = grid[i-1][j];

           Point3D downright = grid[i][j+1];
           Point3D upright = grid[i][j];
           
       /*
	   faceList[dex][0] = downright;
	   faceList[dex][1] = upright;
	   faceList[dex][2] = upleft;
	   Vector3D n1 = (upleft-upright).cross(downright-upright);
	   n1.normalize();
	   normalList[dex] = n1;
	   dex++;
	   
	   faceList[dex][0] = downleft;
	   faceList[dex][1] = downright;
	   faceList[dex][2] = upleft;
	   Vector3D n2 = (upleft-downright).cross(downleft-downright);
	   n2.normalize();
	   normalList[dex] = n2;
	   
	   dex++;
       */





	   faceList[dex][0] = downright;
	   faceList[dex][1] = upright;
	   faceList[dex][2] = downleft;
	   Vector3D n1 = (downleft-upright).cross(downright-upright);
	   n1.normalize();
	   normalList[dex] = n1;
	   dex++;
	   
	   faceList[dex][0] = downleft;
	   faceList[dex][1] = upright;
	   faceList[dex][2] = upleft;
	   Vector3D n2 = (upleft-upright).cross(downleft-upright);
	   n2.normalize();
	   normalList[dex] = n2;
	   
	   dex++;













        }
    }
    
    
    numFace = dex;
    
    
    
    

}



//how about checking the current direction against the normal of the triangle.


//http://www.acm.org/jgt/papers/MollerTrumbore97/code.html
int WorldPortion::intersect_triangle(Point3D orig, Vector3D dir,
                   Point3D vert0, Point3D vert1, Point3D vert2,
                   bool reverse, double *t, double *u, double *v, Vector3D &norm)
{
   Vector3D edge1, edge2, tvec, pvec, qvec;
   double det,inv_det;

   if (reverse)// && m_scale < 0) 
   {
     dir = -1 * dir;
     //if (dir[0] < 0) dir[0] = -dir[0];
     //if (dir[1] < 0) dir[1] = -dir[1];
     //if (dir[2] < 0) dir[2] = -dir[2];

   }
   /* find vectors for two edges sharing vert0 */

   edge1 =  vert1 - vert0;
   edge2 =  vert2 - vert0;

   pvec = dir.cross(edge2);

   det = edge1.dot(pvec);

   if (det < EPSILON)
      return 0;

   /* calculate distance from vert0 to ray origin */
   tvec = orig -  vert0;

   /* calculate U parameter and test bounds */
   *u = tvec.dot(pvec);
   if (*u < 0.0 || *u > det)
      return 0;

   /* prepare to test V parameter */
   qvec = tvec.cross(edge1);

    /* calculate V parameter and test bounds */
   *v = dir.dot(qvec);
   if (*v < 0.0 || *u + *v > det)
      return 0;

   /* calculate t, scale parameters, ray intersects triangle */
   *t = edge2.dot(qvec);
   inv_det = 1.0 / det;
   *t *= inv_det;
   *u *= inv_det;
   *v *= inv_det;
   norm = edge1.cross(edge2);
   norm.normalize();
   return 1;
}








bool WorldPortion::boundingVolumeIntersection(Point3D pos, Vector3D dir, double rad, double &dist)
{
  dist = 0.0f;

  // Relative velocity
  Vector3D dv = dir;
  // Relative position
  Vector3D dp = pos - sphereCenter;
  //Minimal distance squared
  double r = rad + sphereRadius;
  //dP^2-r^2
  double pp = dp[0] * dp[0] + dp[1] * dp[1] + dp[2] * dp[2] - r*r;
  //(1)Check if the spheres are already intersecting
  if ( pp < 0 ) return true;

  //dP*dV
  double pv = dp[0] * dv[0] + dp[1] * dv[1] + dp[2] * dv[2];
  //(2)Check if the spheres are moving away from each other
  if ( pv >= 0 ) return false;

  //dV^2
  double vv = dv[0] * dv[0] + dv[1] * dv[1] + dv[2] * dv[2];
  //(3)Check if the spheres can intersect within 1 frame
  if ( (pv + vv) <= 0 && (vv + 2 * pv + pp) >= 0 ) return false;

  //tmin = -dP*dV/dV*2 
  //the time when the distance between the spheres is minimal
  double tmin = -pv/vv;

  //Discriminant/(4*dV^2) = -(dp^2-r^2+dP*dV*tmin)
  return ( pp + pv * tmin > 0 );
}    







//http://www.edenwaith.com/products/pige/tutorials/collision.php
bool WorldPortion::intersect(Point3D pos, Vector3D dir, double rad, bool reverse, Vector3D &norm, double &dist)
{
    
    
    
   if (!boundingVolumeIntersection(pos, dir, rad, dist))
     return false;
    
    
    
    
    
    
    
    
    
    
    
    
    double u, v;
    for (int i = 0; i < numFace; i++)
    {

      if (m_scale > 0)
      {
        if (intersect_triangle(pos, dir, faceList[i][2], faceList[i][1], faceList[i][0], reverse, &dist, &u, &v, norm) == 1)
        {
	  //if ((m_scale > 0 && dist > -0.01) || (m_scale < 0 && dist < 0.01)) 
          //std::cerr << dist << std::endl;
	  if (dist > -1)
	  {
            norm = normalList[i];
            return true; 
          }
	}
      } 
      else
      {
        if (intersect_triangle(pos, dir, faceList[i][0], faceList[i][1], faceList[i][2], reverse, &dist, &u, &v, norm) == 1)
        {
	  //if ((m_scale > 0 && dist > -0.01) || (m_scale < 0 && dist < 0.01)) 
          //std::cerr << dist << std::endl;
	  if (dist < 1)
	  {
            norm = normalList[i];
            return true; 
          }
	}
      } 
     
    }

    
    
    
    
   
   return false;

}

//http://www.flipcode.com/articles/article_frustumculling.shtml
void WorldPortion::render(Cam *c, int inc)
{
   //only cull if there is a frustum to cull against)
   
  
   
   if (c != NULL)
   {
     if (c->containsSphere(sphereCenter, sphereRadius) == 0) return;
   }
   
   
   if (!m_display) return;
    
   
    glPushMatrix();
    
    glColor3d(1, 1, 1);
    
    
    double jitterx = 0;
    double jittery = 0;
      
    jitterx = cos(incAngle[inc])*0.005;
    jittery = sin(incAngle[inc])*0.005;
    if (m_scale < 0)
    {
      jitterx = -jitterx;
      jittery = -jittery;
    }
    
    double cosinc = cos(incAngle[inc])/5;
    double sininc = sin(incAngle[inc])/5;

        
    for (int j = envStartY; j < envHeight-1; j++)
    {
      //beginning a new strip  
      glBegin(GL_TRIANGLE_STRIP);
        for (int i = envWidth; i > envStartX ; i--)
        {
         Vector3D n1 = normal[i-1][j+1];
         Vector3D n2 = normal[i-1][j];

         if (World::animateNormal)
         {
           n1 = animatedNormals[inc][i-1][j+1];
           n2 = animatedNormals[inc][i-1][j];

           //n1 = Vector3D(n1[0] * cosinc - n1[1] * sininc, n1[0] * sininc + n1[1] * cosinc, n1[2]);
           //n2 = Vector3D(n2[0] * cosinc - n2[1] * sininc, n2[0] * sininc + n2[1] * cosinc, n2[2]);
         }

         glTexCoord2d(textureCoord[i-1][j+1][0]+ jitterx + textureoffsetx,textureCoord[i-1][j+1][1]+ jittery + textureoffsety);
         //glNormal3dv(normal[i-1][j+1].begin());

         glNormal3dv(n1.begin());
         glVertex3dv(grid[i-1][j+1].begin());
       
         glTexCoord2d(textureCoord[i-1][j][0]+ jitterx + textureoffsetx,textureCoord[i-1][j][1]+ jittery + textureoffsety);
         //glNormal3dv(normal[i-1][j].begin());
         glNormal3dv(n2.begin());

         glVertex3dv(grid[i-1][j].begin());

        }

      glEnd();
    }



   if (World::showNormal)
   {
     glColor3d(1,1,1);
     glDisable(GL_TEXTURE_2D);

      for (int j = envStartY; j < envHeight-1; j++)
      {
          for (int i = envWidth; i > envStartX ; i--)
          {
           Vector3D n1 = normal[i-1][j+1];
           Vector3D n2 = normal[i-1][j];

           if (World::animateNormal)
           {
             n1 = animatedNormals[inc][i-1][j+1];
             n2 = animatedNormals[inc][i-1][j];
           }

           glBegin(GL_LINES);
             glVertex3dv(grid[i-1][j+1].begin());
             glVertex3dv((grid[i-1][j+1] + 10*n1).begin());
             glVertex3dv(grid[i-1][j].begin());
             glVertex3dv((grid[i-1][j]+10*n2).begin());
           glEnd();
         }
     }
     
     
     glEnable(GL_TEXTURE_2D);
   }
   
   
   
   
   
   
   if (World::showFaceNormal)
   {
     glColor3d(1,1,1);
     glDisable(GL_TEXTURE_2D);
     
     
      for (int i = 0; i < numFace; i++)
      {
        glColor3d(1,1,1);
	Point3D center = faceList[i][0] + faceList[i][1] + faceList[i][2];
	center[0] = center[0] / 3;
	center[1] = center[1] / 3;
	center[2] = center[2] / 3;
	glColor3d(1,0,0);
	glBegin(GL_LINES);
        glVertex3dv(center.begin());
        glVertex3dv((center+10*normalList[i]).begin());
        glEnd();
     
      }	
      
     
     glEnable(GL_TEXTURE_2D);
   }
   
   
   
   

   
   
   
   

   glPopMatrix();

 
 if (World::showBound)
   {
     glColor3d(1,1,1);
     glDisable(GL_TEXTURE_2D);

     Point3D center = Point3D((BBp1[0] + BBp2[0]) / 2,(BBp1[1] + BBp2[1]) / 2,(BBp1[2] + BBp2[2]) / 2);
     double radius = (BBp2 - center).length();

/*     
     {
     glPushMatrix();
     glColor3d(1,0,0);
     glTranslated(BBp1[0], BBp1[1], BBp1[2]);
     GLUquadricObj* qsphere = gluNewQuadric();
     gluSphere(qsphere, 10, 8, 8);
     gluDeleteQuadric(qsphere);
     glPopMatrix();
     }
     
     
     
     {
     glPushMatrix();
     glColor3d(0,0,1);
     glTranslated(BBp2[0], BBp2[1], BBp2[2]);
     GLUquadricObj* qsphere = gluNewQuadric();
     gluSphere(qsphere, 10, 8, 8);
     gluDeleteQuadric(qsphere);
     glPopMatrix();
     }
     
  */   
     
     
     
     
     
          
     {
     glPushMatrix();
     glColor3d(1,0,1);
     glTranslated(center[0], center[1], center[2]);
     GLUquadricObj* qsphere = gluNewQuadric();
     gluSphere(qsphere, radius, 8, 8);
     gluDeleteQuadric(qsphere);
     glPopMatrix();
     }
     
        
     glEnable(GL_TEXTURE_2D);
   }
  
}



Particle::Particle(Point3D pos, Vector3D vel, Vector3D accel, double fade, Colour c)
{
  this->pos = pos;
  this->vel = vel;
  this->accel = accel;
  this->fade = fade;
  this->life = 1.0;
  this->col = c; //Colour((double)rand() / RAND_MAX,(double)rand() / RAND_MAX,(double)rand() / RAND_MAX);
  int rotangle = rand() % 360;

  sinTexAng = sin(degToRad(rotangle));
  cosTexAng = cos(degToRad(rotangle));



}

Particle::Particle()
{
  this->pos = Point3D(0,0,0);
  this->vel = Vector3D(0,0,0);
  this->accel = Vector3D(0,0,0);
  this->fade = 1;
  this->life = 0;
  this->col = Colour(1,1,1);
}

void Particle::sphereBillboardBegin(Point3D cam)
{


    float mat[16];

    glGetFloatv(GL_MODELVIEW_MATRIX, mat);
    buildRot(-180*atan2f(mat[8], mat[10])/M_PI, 0, 1, 0, mat);
    glMultMatrixf(mat);
}


void Particle::buildRot(float theta, float x, float y, float z, float m[16]) {
    float d = x*x + y*y + z*z;
    float ct = cosf(degToRad(theta)), st = sinf(degToRad(theta));

    /* normalize */
    if (d > 0) {
	d = 1/d;
	x *= d;
	y *= d;
	z *= d;
    }

    m[ 0] = 1; m[ 1] = 0; m[ 2] = 0; m[ 3] = 0;
    m[ 4] = 0; m[ 5] = 1; m[ 6] = 0; m[ 7] = 0;
    m[ 8] = 0; m[ 9] = 0; m[10] = 1; m[11] = 0;
    m[12] = 0; m[13] = 0; m[14] = 0; m[15] = 1;

    /* R = uu' + cos(theta)*(I-uu') + sin(theta)*S
     *
     * S =  0  -z   y    u' = (x, y, z)
     *	    z   0  -x
     *	   -y   x   0
     */

     m[0] = x*x + ct*(1-x*x) + st*0;
     m[4] = x*y + ct*(0-x*y) + st*-z;
     m[8] = x*z + ct*(0-x*z) + st*y;

     m[1] = y*x + ct*(0-y*x) + st*z;
     m[5] = y*y + ct*(1-y*y) + st*0;
     m[9] = y*z + ct*(0-y*z) + st*-x;

     m[2] = z*x + ct*(0-z*x) + st*-y;
     m[6] = z*y + ct*(0-z*y) + st*x;
     m[10]= z*z + ct*(1-z*z) + st*0;
}






void Particle::render()
{
  if (life > 0)
  {
    //glPushMatrix();
    //sphereBillboardBegin(camPoint);
    
   //http://www.lighthouse3d.com/opengl/billboarding/index.php3?billWhere 


  
    float modelview[16];
    int i,j;

    // save the current modelview matrix
    glPushMatrix();

    // get the current modelview matrix
    glTranslated(pos[0], pos[1], pos[2]);
   
     
    glGetFloatv(GL_MODELVIEW_MATRIX , modelview);

    // undo all rotations
    // beware all scaling is lost as well 
    for( i=0; i<3; i++ ) 
     for( j=0; j<3; j++ ) 
     {
      if ( i==j )
        modelview[i*4+j] = 1.0;
      else
        modelview[i*4+j] = 0.0;
     }

    // set the modelview with no rotations and scaling
    glLoadMatrixf(modelview);
    
    Colour ncol = life * col;
    glColor3d(ncol.R(),ncol.G(),ncol.B());


  
    Point2D tex11 = Point2D(1,1);
    Point2D tex01 = Point2D(0,1);
    Point2D tex10 = Point2D(1,0);
    Point2D tex00 = Point2D(0,0);

    //x' = x cos f - y sin f
    //y' = y cos f + x sin f

    Point2D rottex11;
    Point2D rottex01;
    Point2D rottex10;
    Point2D rottex00;

    tex11[0] = tex11[0] - 0.5;
    tex11[1] = tex11[1] - 0.5;
    tex10[0] = tex10[0] - 0.5;
    tex10[1] = tex10[1] - 0.5;
    tex01[0] = tex01[0] - 0.5;
    tex01[1] = tex01[1] - 0.5;
    tex00[0] = tex00[0] - 0.5;
    tex00[1] = tex00[1] - 0.5;




    rottex11[0] = tex11[0] * cosTexAng - tex11[1] * sinTexAng;
    rottex11[1] = tex11[1] * cosTexAng + tex11[0] * sinTexAng;
    rottex10[0] = tex10[0] * cosTexAng - tex10[1] * sinTexAng;
    rottex10[1] = tex10[1] * cosTexAng + tex10[0] * sinTexAng;
    rottex01[0] = tex01[0] * cosTexAng - tex01[1] * sinTexAng;
    rottex01[1] = tex01[1] * cosTexAng + tex01[0] * sinTexAng;
    rottex00[0] = tex00[0] * cosTexAng - tex00[1] * sinTexAng;
    rottex00[1] = tex00[1] * cosTexAng + tex00[0] * sinTexAng;

    rottex11[0] = rottex11[0] + 0.5;
    rottex11[1] = rottex11[1] + 0.5;
    rottex10[0] = rottex10[0] + 0.5;
    rottex10[1] = rottex10[1] + 0.5;
    rottex01[0] = rottex01[0] + 0.5;
    rottex01[1] = rottex01[1] + 0.5;
    rottex00[0] = rottex00[0] + 0.5;
    rottex00[1] = rottex00[1] + 0.5;





    glBegin(GL_TRIANGLE_STRIP);
      //glNormal3d(0,0,1); glTexCoord2d(rottex11[0],rottex11[1]); glVertex3f(0.5,0.5,0); // Top Right
      //glNormal3d(0,0,1); glTexCoord2d(rottex01[0],rottex01[1]); glVertex3f(-0.5,0.5,0); // Top Left
      //glNormal3d(0,0,1); glTexCoord2d(rottex10[0],rottex10[1]); glVertex3f(0.5,-0.5,0); // Bottom Right
      //glNormal3d(0,0,1); glTexCoord2d(rottex00[0],rottex00[1]); glVertex3f(-0.5,-0.5,0); // Bottom Left      
      glNormal3d(0,0,1); glTexCoord2d(rottex11[0],rottex11[1]); glVertex3f(0.5,0.5,0); // Top Right
      glNormal3d(0,0,1); glTexCoord2d(rottex01[0],rottex01[1]); glVertex3f(-0.5,0.5,0); // Top Left
      glNormal3d(0,0,1); glTexCoord2d(rottex10[0],rottex10[1]); glVertex3f(0.5,-0.5,0); // Bottom Right
      glNormal3d(0,0,1); glTexCoord2d(rottex00[0],rottex00[1]); glVertex3f(-0.5,-0.5,0); // Bottom Left      

    glEnd();


    /*  
    glBegin(GL_TRIANGLE_STRIP);
      //glNormal3d(0,0,1); glTexCoord2d(1,1); glVertex3f(pos[0]+0.5f,pos[1]+0.5f,pos[2]); // Top Right
      //glNormal3d(0,0,1); glTexCoord2d(0,1); glVertex3f(pos[0]-0.5f,pos[1]+0.5f,pos[2]); // Top Left
      //glNormal3d(0,0,1); glTexCoord2d(1,0); glVertex3f(pos[0]+0.5f,pos[1]-0.5f,pos[2]); // Bottom Right
      //glNormal3d(0,0,1); glTexCoord2d(0,0); glVertex3f(pos[0]-0.5f,pos[1]-0.5f,pos[2]); // Bottom Left
      glNormal3d(0,0,1); glTexCoord2d(1,1); glVertex3f(0.5f,0.5f,0); // Top Right
      glNormal3d(0,0,1); glTexCoord2d(0,1); glVertex3f(-0.5f,0.5f,0); // Top Left
      glNormal3d(0,0,1); glTexCoord2d(1,0); glVertex3f(0.5f,-0.5f,0); // Bottom Right
      glNormal3d(0,0,1); glTexCoord2d(0,0); glVertex3f(-0.5f,-0.5f,0); // Bottom Left      
    glEnd();
    */

 
   // restores the modelview matrix
   glPopMatrix();
    
    
  }  
}

void Particle::tick()
{
  
  if (life > 0)
  {
    life = life - fade;
    Vector3D oldvel = vel;
    vel = vel + accel;
    //viscocity check, have it stop if we are about to reverse direction
    if ((oldvel[0] > 0 && vel[0] < 0) || (oldvel[0] < 0 && vel[0] > 0)) { vel[0] = 0; accel[0] = 0; }
    if ((oldvel[1] > 0 && vel[1] < 0) || (oldvel[1] < 0 && vel[1] > 0)) { vel[1] = 0; accel[1] = 0; }
    if ((oldvel[2] > 0 && vel[2] < 0) || (oldvel[2] < 0 && vel[2] > 0)) { vel[2] = 0; accel[2] = 0; }
    pos = pos + vel;
    if (life < 0) life = 0;
  }
}




ParticleEngine::ParticleEngine(Point3D pos, double velFactor, double accFactor, int num, double fade, Colour c, double colVariation, ParticleMode pmode, GLuint texture)
{
  alive = true;
  done = false;
  numParticle = num;
  this->pos = pos;
  this->vel = vel;
  this->accel = accel;
  this->fade = fade;
  this->texture = texture;
  this->particleMode = pmode;
  this->col = c;
  this->velFactor = velFactor;
  this->accFactor = accFactor;
  this->colVariation = colVariation;
  
  particles = new Particle[numParticle];
  
  for (int i = 0; i < numParticle; i++)
  {
    //int sign1 = rand() % 2 == 0 ? 1 : -1;
    //int sign2 = rand() % 2 == 0 ? 1 : -1;
    //int sign3 = rand() % 2 == 0 ? 1 : -1;
    //Vector3D newvel( sign1 * (double)rand()/2 / RAND_MAX, sign2 * (double)rand() /2/ RAND_MAX, sign3 * (double)rand() /2/ RAND_MAX);
    double angx = degToRad(rand()%360);  
    double angy = degToRad(rand()%360);  
    double angz = degToRad(rand()%360);  
    
    Vector3D newvel (1,1,1);
    
    // rotation around x axis (a.k.a. pitch)
    newvel[1] = cos(angx)*newvel[1] - sin(angx)*newvel[2];
    newvel[2] = sin(angx)*newvel[1] + cos(angx)*newvel[2];

    // rotation around y axis (a.k.a. yaw)
    newvel[2] = cos(angy)*newvel[2] - sin(angy)*newvel[0];
    newvel[0] = sin(angy)*newvel[2] + cos(angy)*newvel[0];

    // rotation around z axis (a.k.a. roll)
    newvel[0] = cos(angz)*newvel[0] - sin(angz)*newvel[1];
    newvel[1] = sin(angz)*newvel[0] + cos(angz)*newvel[1];    
    
    
    

    //Vector3D newvel( sign1 * cos(r), sign2 * sin(r), sign3 * sin(r)+cos(r));
    newvel = ((double)rand() / RAND_MAX + 0.2) * newvel;
    Vector3D paccel = -((double)rand() / RAND_MAX / 50)*newvel;
    paccel = accFactor * paccel;
    Colour c = col;
    Colour randCol(((double)rand()/RAND_MAX), ((double)rand()/RAND_MAX), ((double)rand()/RAND_MAX));
    if (rand() % 2 == 0)
      c = (1.0 - colVariation)*c - (colVariation*randCol);
    else
      c = (1.0 - colVariation)*c + (colVariation*randCol);
    c.clamp();
    
    if (particleMode == PARTICLE_FIRE)
      particles[i] = Particle(pos + 0.2*newvel, velFactor*newvel, paccel, fade + (double)rand() /2/ RAND_MAX, c);
    else
      particles[i] = Particle(pos + 0.2*newvel, velFactor*newvel, paccel, fade + (double)rand() /25/ RAND_MAX, c);
    
    if (particleMode == PARTICLE_EXPLODE)
      alive = false;
  }
}
    
ParticleEngine::~ParticleEngine()
{
  delete [] particles;
}
    
void ParticleEngine::render()
{
    glEnable(GL_TEXTURE_2D);

    glBindTexture( GL_TEXTURE_2D, texture );
    glDepthMask(GL_FALSE);
    //glDisable( GL_DEPTH_TEST );
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE);

  for (int i = 0; i < numParticle; i++)
    particles[i].render();

    glDisable(GL_BLEND);
    //glEnable( GL_DEPTH_TEST );
    glDepthMask(GL_TRUE);

    glDisable(GL_TEXTURE_2D);

}

void ParticleEngine::setPos(Point3D newpos)
{
  pos = newpos;
}

void ParticleEngine::tick()
{
//  std::cerr << "tick" << std::endl;
  done = !alive; //we can only be done if we are told to die
  
  for (int i = 0; i < numParticle; i++)
  {
   particles[i].tick();

   //only create new particles if the engine is still alive, and if we want to
   if (!particles[i].alive() && this->alive)
   {
     //int sign1 = rand() % 2 == 0 ? 1 : -1;
     //int sign2 = rand() % 2 == 0 ? 1 : -1;
     //int sign3 = rand() % 2 == 0 ? 1 : -1;
//     Vector3D newvel( sign1 * (double)rand()/2 / RAND_MAX, sign2 * (double)rand() /2/ RAND_MAX, sign3 * (double)rand() /2/ RAND_MAX);
    // int r = rand();
    // Vector3D newvel( sign1 * cos(r), sign2 * sin(r), sign3 * sin(r)+cos(r));

    double angx = degToRad(rand()%360);  
    double angy = degToRad(rand()%360);  
    double angz = degToRad(rand()%360);  
    
    Vector3D newvel (1,1,1);
    
    // rotation around x axis (a.k.a. pitch)
    newvel[1] = cos(angx)*newvel[1] - sin(angx)*newvel[2];
    newvel[2] = sin(angx)*newvel[1] + cos(angx)*newvel[2];

    // rotation around y axis (a.k.a. yaw)
    newvel[2] = cos(angy)*newvel[2] - sin(angy)*newvel[0];
    newvel[0] = sin(angy)*newvel[2] + cos(angy)*newvel[0];

    // rotation around z axis (a.k.a. roll)
    newvel[0] = cos(angz)*newvel[0] - sin(angz)*newvel[1];
    newvel[1] = sin(angz)*newvel[0] + cos(angz)*newvel[1];    
        
    newvel = ((double)rand() / RAND_MAX + 0.2) * newvel;
    Vector3D paccel = -((double)rand() / RAND_MAX / 50)*newvel;
    paccel = accFactor * paccel;
    particles[i] = Particle(pos+0.2*newvel, velFactor*newvel, paccel, fade + (double)rand() /2/ RAND_MAX, col);
   }
   done = done && !particles[i].alive();  //we can only be done if all the particles are dead
  }

}

